Xapian::Query Class Reference

Class representing a query. More...

## Public Types

enum | op { , OP_ELITE_SET = 10 }
| Query operators. More...
enum | { WILDCARD_LIMIT_ERROR, WILDCARD_LIMIT_FIRST, WILDCARD_LIMIT_MOST_FREQUENT }

## Public Member Functions

| Query ()
| Default constructor.
| ~Query ()
| Destructor.
| Query (const Query &o)
| Copying is allowed. More...
Query & | operator= (const Query &o)
| Copying is allowed. More...
| Query (const std::string &term, Xapian::termcount wqf=1, Xapian::termpos pos=0)
| Construct a Query object for a term. More...
| Query (Xapian::PostingSource *source)
| Construct a Query object for a PostingSource. More...
| Query (op op_, const std::string &pattern, Xapian::termcount max_expansion=0, int max_type=WILDCARD_LIMIT_ERROR, op combiner=OP_SYNONYM)
| Query constructor for OP_WILDCARD queries. More...
op | get_type () const
| Get the type of the top level of the query. More...
size_t | get_num_subqueries () const
| Get the number of subqueries of the top level query. More...
const Query | get_subquery (size_t n) const
| Read a top level subquery. More...

## Detailed Description

Class representing a query.

## Member Enumeration Documentation

anonymous enum

Enumerator
WILDCARD_LIMIT_ERROR | Throw an error if OP_WILDCARD exceeds its expansion limit. Xapian::WildcardError will be thrown when the query is actually run.
WILDCARD_LIMIT_FIRST | Stop expanding when OP_WILDCARD reaches its expansion limit. This makes the wildcard expand to only the first N terms (sorted by byte order).

WILDCARD_LIMIT_MOST_FREQUENT

Limit OP_WILDCARD expansion to the most frequent terms.

If OP_WILDCARD would expand to more than its expansion limit, the most frequent terms are taken. This approach works well for cases such as expanding a partial term at the end of a query string which the user hasn't finished typing yet - as well as being less expense to evaluate than the full expansion, using only the most frequent terms tends to give better results too.

enum Xapian::Query::op

Query operators.

Enumerator

OP_ELITE_SET

Pick the best N subqueries and combine with OP_OR.

If you want to implement a feature which finds documents similar to a piece of text, an obvious approach is to build an "OR" query from all the terms in the text, and run this query against a database containing the documents. However such a query can contain a lots of terms and be quite slow to perform, yet many of these terms don't contribute usefully to the results.

The OP_ELITE_SET operator can be used instead of OP_OR in this situation. OP_ELITE_SET selects the most important ''N'' terms and then acts as an OP_OR query with just these, ignoring any other terms. This will usually return results just as good as the full OP_OR query, but much faster.

In general, the OP_ELITE_SET operator can be used when you have a large OR query, but it doesn't matter if the search completely ignores some of the less important terms in the query.

The subqueries don't have to be terms, but if they aren't then OP_ELITE_SET will look at the estimated frequencies of the subqueries and so could pick a subset which don't actually match any documents even if the full OR would match some.

You can specify a parameter to the query constructor which control the number of terms which OP_ELITE_SET will pick. If not specified, this defaults to 10 (Xapian used to default to `ceil(sqrt(number_of_subqueries))` if there are more than 100 subqueries, but this rather arbitrary special case was dropped in 1.3.0). For example, this will pick the best 7 terms:

            Xapian::Query query(Xapian::Query::OP_ELITE_SET, subqs.begin(), subqs.end(), 7);

If the number of subqueries is less than this threshold, OP_ELITE_SET behaves identically to OP_OR.

## Constructor & Destructor Documentation

Xapian::Query::Query | ( | const Query & | o | ) |

inline

Copying is allowed.

The internals are reference counted, so copying is cheap.

Xapian::Query::Query | ( | const std::string & | term,
|  | Xapian::termcount | wqf = `1`,
|  | Xapian::termpos | pos = `0`
| ) |  |

Construct a Query object for a term.

Xapian::Query::Query | ( | Xapian::PostingSource * | source | ) |

explicit

Construct a Query object for a PostingSource.

Xapian::Query::Query | ( | op | op_,
|  | const std::string & | pattern,
|  | Xapian::termcount | max_expansion = `0`,
|  | int | max_type = `WILDCARD_LIMIT_ERROR`,
|  | op | combiner = `OP_SYNONYM`
| ) |  |

Query constructor for OP_WILDCARD queries.

Parameters

  op | Must be OP_WILDCARD
  pattern | The wildcard pattern - currently this is just a string and the wildcard expands to terms which start with exactly this string.
  max_expansion | The maximum number of terms to expand to (default: 0, which means no limit)
  max_type | How to enforce max_expansion - one of WILDCARD_LIMIT_ERROR (the default), WILDCARD_LIMIT_FIRST or WILDCARD_LIMIT_MOST_FREQUENT.
  combiner | The to combine the terms with - one of OP_SYNONYM (the default), OP_OR or OP_MAX.

## Member Function Documentation

size_t Xapian::Query::get_num_subqueries | ( |  | ) | const

Get the number of subqueries of the top level query.

const Query Xapian::Query::get_subquery | ( | size_t | n | ) | const

Read a top level subquery.

Parameters

  n | Return the n-th subquery (starting from 0) - only valid when 0 <= n < get_num_subqueries().

op Xapian::Query::get_type | ( |  | ) | const

Get the type of the top level of the query.

Query& Xapian::Query::operator= | ( | const Query & | o | ) |

inline

Copying is allowed.

The internals are reference counted, so assignment is cheap.

The documentation for this class was generated from the following file:

- xapian/query.h